import odeToJava.*;   // import for use of package components
import odeToJava.modules.*;
import odeToJava.functions.*;
import odeToJava.plotter.*;
import odeToJava.interpolants.*;

/*
   the template class
*/
public class ErkSDTemplate
{
     /*
        main
     */
     public static void main(String[] args)
     {

          /*
             this is where the template essentially starts
          */

          // the function
          
          ODE function = new FunctionTemplate();   // define function in FunctionTemplate.java

          // the span
          
          Span span = new Span(/*t0*/, /*tf*/);   // only first constructor scheme (no interpolation)

          // the initial vector value(s)

          int n =   // indicate the dimension of the problem

          double[] x = new double[n];   // initialize array object

          x[0] =   // fill the array with the initial values
          // etc . . .

          // initial stepsize
          
          double h0 =   // must be > 0

          // the Butcher tableau

          int s =   // specify the stage of the method

          double[][] a = new double[s][s];   // initialize components
          double[] b = new double[s];
          double[] c = new double[s];
          String FSAL;   // whether to enable first same as last (if the scheme has this property)

          a[0][0] =   // fill in tableau's a matrix
          // etc . . .
      		
          b[0] =   // fill in tableau's b array
          // etc . . .
		
          c[0] =   // fill in tableau's c array

          FSAL =   // choose 1) "FSALenabled or 2) "FSALdisabled"

          Btableau butcher = new Btableau(a, b, c, FSAL);   // initialize object with components

          // absolute tolerance

          double atol =   // fill in value

          // relative tolerance
          
          double rtol =   // fill in value

          // the file name
          
          String fileName = "";   // default to no file writing

          // stats option
          
          String stats =   // choose 1) "Stats_On" 2) "Stats_Intermediate or 3) "Stats_Off"

          /*
             this is where the template essentially ends
          */

          // run the ERK /w step doubling scheme with above parameters

          ErkSD.erk_sd(function, span, x, h0, butcher, atol, rtol, fileName, stats);
     }
}
